	scan=0x67
	ktest=0x102
	wkey=0x127
	cls=0xd9
	whex=0x13a

	.area codigo (abs)
        .org    0x416

	jp prog
	tope=6000      ;1 Kb de matriz

num:	.dw 1
numb:	.db 1,0,0

incbcd:	ld b,#3		;Incrementa la variable en BCD
	ld hl,#numb
	scf
bincb:	ld a,(hl)
	adc a,#0
	daa
	ld (hl),a
	inc hl
	djnz bincb
	ret

prtbcd:	ld bc,#0x300	;Imprime la variable en BCD
	ld hl,#numb+2
bprtb:	ld a,(hl)
	call whex
	dec hl
	djnz bprtb
	ret

testb:	ld hl,#matriz	;Comprueba el bit DE
	ld a,e		;devuelve el resultado en ZF
	and #7
	ld c,a
	ld b,#3
btestb:	srl d
	rr e
	djnz btestb
	ld b,c
	ld a,c
	cp #0
	ld a,#1
	jr z,s1
btest1:	sla a
	djnz btest1
s1:	add hl,de
	ld b,(hl)
	and b
	ret

setb:	ld hl,#matriz	;Pone a 1 el bit DE
	ld b,#3		
	ld a,e
	and #7
	ld c,a
bsetb:	srl d
	rr e
	djnz bsetb
	ld b,c
	ld a,c
	cp #0
	ld a,#1
	jr z,s2
bset1:	sla a
	djnz bset1
s2:	add hl,de
	or (hl)
	ld (hl),a
	ret

prog:	ld a,#32		;Borra pantalla
	call cls
	ld hl,#1		;inizializa variables
	ld (num),hl
	ld hl,#numb
	ld a,#1
	ld (hl),a
	xor a
	inc hl
	ld (hl),a
	inc hl
	ld (hl),a
	ld hl,#matriz		;Borra la matriz original
	ld de,#matriz+1
	ld bc,#tope/8
	xor a
	ld (hl),a
	ldir

buc:	ld hl,(num)
	inc hl
	ld (num),hl
	call incbcd
	ld de,(num)
	call testb
	jr nz,otro

	ld de,#0
bucs:	ld bc,#tope
	ld hl,(num)
	add hl,de
	ld a,l
	sub c
	ld a,h
	sbc a,b
	jr nc,otrop		
	ex de,hl
	push de
	call setb
	pop de
	jr bucs

otrop:	call prtbcd
dotro:	call scan
	call ktest
	jr c,dotro
otro:	ld de,(num)
	ld bc,#tope-1
	ld a,e
	sub c
	ld a,d
	sbc a,b
	jr c,buc
	
	call wkey
	ret
matriz:	
