#include "forms.h"
#include "woprform.h"
#include "debugform.h"
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <signal.h>

 
int alflag=0;

void alarma()
{
	alflag++;
	if (alflag>5) {
/*		fl_check_forms(); */
		alflag=1;
	}
}

extern void setupX11();
extern void Draw7s(unsigned char dat,int pos);
extern void wopr(int argc,char **argv);

FD_woprform *fd_woprform;
FD_debugform *fd_debugform;

int main(int argc, char *argv[])
{
	int i;
	struct itimerval t0,t1;
	struct sigaction act0,act1;
	

   fl_initialize(&argc, argv, 0, 0, 0);
   fd_woprform = create_form_woprform();
   fd_debugform = create_form_debugform();

   /* fill-in form initialization code */

   fl_set_browser_fontstyle(fd_debugform->browserDis,FL_FIXED_STYLE);
   fl_set_browser_fontsize(fd_debugform->browserDis,14);
   fl_set_browser_fontstyle(fd_debugform->browserStack,FL_FIXED_STYLE);
   fl_set_browser_fontsize(fd_debugform->browserStack,14);
   fl_set_browser_fontstyle(fd_debugform->browserMem,FL_FIXED_STYLE);
   fl_set_browser_fontsize(fd_debugform->browserMem,14);

   fl_set_input_scroll(fd_debugform->inputMem,0);
   fl_set_input_scroll(fd_debugform->inputBrk,0);
   fl_set_input_scroll(fd_debugform->inputA,0);
   fl_set_input_scroll(fd_debugform->inputA1,0);
   fl_set_input_scroll(fd_debugform->inputBC,0);
   fl_set_input_scroll(fd_debugform->inputBC1,0);
   fl_set_input_scroll(fd_debugform->inputDE,0);
   fl_set_input_scroll(fd_debugform->inputDE1,0);
   fl_set_input_scroll(fd_debugform->inputHL,0);
   fl_set_input_scroll(fd_debugform->inputHL1,0);
   fl_set_input_scroll(fd_debugform->inputIX,0);
   fl_set_input_scroll(fd_debugform->inputIY,0);
   fl_set_input_scroll(fd_debugform->inputSP,0);
   fl_set_input_scroll(fd_debugform->inputPC,0);
   fl_set_input_scroll(fd_debugform->inputI,0);
   fl_set_input_scroll(fd_debugform->inputR,0);
   fl_set_input_scroll(fd_debugform->inputIM,0);

   fl_deactivate_object(fd_debugform->groupReg);
   
   /* show the first form */
   fl_show_form(fd_debugform->debugform,FL_PLACE_CENTER,FL_FULLBORDER,"DEBUG Window");
   fl_show_form(fd_woprform->woprform,FL_PLACE_CENTER,FL_FULLBORDER,"W.O.P.R. Emulator by Jess Arias");

   setup7seg();
   for (i=0;i<6;i++) Draw7s(0x3f,i);
   fl_check_forms();

   t0.it_interval.tv_sec=0;
   t0.it_interval.tv_usec=50000;
   t0.it_value=t0.it_interval;
	
   act0.sa_handler=alarma;
   act0.sa_mask=0;
   act0.sa_flags=SA_RESTART;
   act0.sa_restorer=NULL;
	
   sigaction(SIGALRM,&act0,&act1);
   setitimer(ITIMER_REAL,&t0,&t1);

   wopr(argc,argv);
   return 0;
}

